rem list_PhysicalDrive.vbs by cdob
rem
rem based on: How Can I Correlate Logical Drives and Physical Disks?
rem  http://www.microsoft.com/technet/scriptcenter/resources/qanda/may05/hey0523.mspx

ComputerName = "."
Set wmiServices  = GetObject ("winmgmts:{impersonationLevel=Impersonate}!//"  & ComputerName)

' Get physical disk drive
Set wmiDiskDrives =  wmiServices.ExecQuery ("SELECT * FROM Win32_DiskDrive")

For Each wmiDiskDrive In wmiDiskDrives
  strDevices=strDevices & wmiDiskDrive.Index & "  " & wmiDiskDrive.DeviceID  _
      & "  " &  wmiDiskDrive.caption & "  "

  'Use the disk drive device id to find associated partition
  query = "ASSOCIATORS OF {Win32_DiskDrive.DeviceID='" _
      & wmiDiskDrive.DeviceID & "'} WHERE AssocClass = Win32_DiskDriveToDiskPartition"
  Set wmiDiskPartitions = wmiServices.ExecQuery(query)

  For Each wmiDiskPartition In wmiDiskPartitions
    'Use partition device id to find logical disk
    Set wmiLogicalDisks = wmiServices.ExecQuery ("ASSOCIATORS OF {Win32_DiskPartition.DeviceID='" _
      & wmiDiskPartition.DeviceID & "'} WHERE AssocClass = Win32_LogicalDiskToPartition")

    For Each wmiLogicalDisk In wmiLogicalDisks
      strDevices=strDevices & wmiLogicalDisk.DeviceID & " "
    Next
  Next
  strDevices=strDevices & vbCrLf

Next

WScript.Echo strDevices