@echo off
setlocal EnableExtensions EnableDelayedExpansion

rem Chainboot copy files v0.02
rem created by cdob

rem based on s4e http://www.911cd.net/forums//index.php?showtopic=21242 
rem Boot from USB/Firewire HD without BIOS support, Fake Signature Method


pushd "%~sdp0"

set Target=%~2
if "%Target%"=="" set Target=%~sdp0usb_temp

set BartPE_Root=%~1
if "%BartPE_Root%"=="" (
  echo read input.inf
  if not exist ..\..\input.inf (
    echo ..\..\input.inf not found &pause &popd &goto :eof)

  FOR /f "tokens=1* delims== skip=1 eol=;" %%a IN (..\..\input.inf) DO IF "%%a"=="fulloutdir" SET OutDir=%%b
  SET last_char=!OutDir:~-1!
  IF "!last_char!"=="\" set OutDir=!OutDir:~0,-1!
  
  set BartPE_Root=!OutDir!\I386
)

echo Setupldr.bin PE_Root %BartPE_Root%
if not exist "%BartPE_Root%\setupldr.bin" (
  echo "%BartPE_Root%\setupldr.bin" not found &pause &popd &goto :eof)

rem copy_files ========================================================
if not exist "%Target%\minint\system32\drivers" md "%Target%\minint\system32\drivers"
echo ntdetect.com
copy "%BartPE_Root%\ntdetect.com" "%Target%\"
echo ntldr
copy "%BartPE_Root%\setupldr.bin" "%Target%\ntldr"

rem parse txtsetup.sif
pushd "%BartPE_Root%"
set copy_flag=off
FOR /f "tokens=1-3* delims=.,= " %%a IN (txtsetup.sif) DO (
  SET first_char=%%a
  IF "!first_char:~0,1!"=="[" SET copy_flag=off
  IF /I "%%b"=="Load]" SET copy_flag=on

  rem support both expanded and compressed files
  set ext=%%c
  set file=%%b.!ext:~0,-1!?
  IF "!copy_flag!"=="on" (
    if exist "system32\!file!" call :ccopy !file! system32 system32
    if exist "system32\drivers\!file!" call :ccopy !file! system32\drivers system32\drivers
  )

  IF /I "%%a"=="AnsiCodepage" call :ccopy !file! system32 system32
  IF /I "%%a"=="OEMCodepage" call :ccopy !file! system32 system32
  IF /I "%%a"=="UnicodeCasetable" call :ccopy !file! system32 system32
  IF /I "%%a"=="OemHalFont" call :ccopy !file! system32 system32
)
popd

pushd "%BartPE_Root%"
FOR %%a in (setupl*.bin) do (echo %%a &copy %%a "%Target%\minint\")
FOR %%a in (txtset*.si? biosinfo.in?) do (call :ccopy %%a .)
popd

pushd "%BartPE_Root%\system32"
FOR %%a in (biosinfo.in? ntoskr*.ex? ntkrnlmp.ex? kdcom.dl? bootvid.dl?
  setupreg.hi? win*.si?  CTYPE.NL? locale.nl? L_INTL.NL? SORTKEY.NL? 
  SORTTBLS.NL? UNICODE.NL? VGAOEM.FO? migrate.in?) do (
 call :ccopy %%a . system32)

rem support winnt.sif [MassStorageDrivers]
if exist $OEM$ %SystemRoot%\system32\xcopy.exe /s /Y $OEM$ "%Target%\minint\system32\$OEM$\"
popd

pushd "%BartPE_Root%\system32\drivers"
FOR %%a in (setupdd.sy? SPDDLANG.sy? WMILIB.sy? OPRGHDLR.sy? 1394BUS.sy?
  PCIIDEX.sy? HIDPARSE.sy? HIDCLASS.sy? kbdclass.sy? CLASSPNP.sy?
  SCSIPORT.sy? USBPORT.sy? USBD.sy? NDIS.sy? MUP.sy?) do (
 call :ccopy %%a . system32\drivers)
popd

popd
goto :eof


:ccopy
  echo. &echo %1
  SET trunc_name=%~1
  SET trunc_name=%trunc_name:~0,-1%
  
  rem http://msdn.microsoft.com/en-us/library/bb417343.aspx#microsoftmakecabusersguide
  SET makecab_options=/D CompressionType=LZX /D CompressionMemory=21 /D CompressionLevel=2

  set ccopyTarget=%Target%\minint
  if not "%3"=="" set ccopyTarget=%Target%\minint\%3
  
  for %%a in ("%2\%1") do (
      rem echo ccopy %%a
      SET last_char=%%~a
      SET last_char=!last_char:~-1!
      IF "!last_char!"=="_" (
        echo copy "%%~a" "%ccopyTarget%"
        copy "%%~a" "%ccopyTarget%"
      ) else (
        echo makecab.exe "%%~a" /L "%ccopyTarget%"
        %SystemRoot%\system32\makecab.exe %makecab_options% "%%~a" /L "%ccopyTarget%" &echo.
        rem cab creation failed, emergency file copy
        if not exist "%ccopyTarget%\%trunc_name%?" copy "%%~a" "%ccopyTarget%"
      )
  )
goto :eof
